=== debian/changelog ===
python-igraph (0.9.0-2) unstable; urgency=medium

  * d/control: add cmake to B-D. (Closes: #983696)

 -- TANIGUCHI Takaki <takaki@debian.org>  Mon, 01 Mar 2021 00:26:28 +0900

python-igraph (0.9.0-1) unstable; urgency=medium

  * New upstream version 0.9.0
  * Bump Standards-Version to 4.5.1
  * Bump debian-compat to 13

 -- TANIGUCHI Takaki <takaki@debian.org>  Sun, 28 Feb 2021 17:44:07 +0900
